/*
    libporty - background tasks (threads mainly)
    Copyright (C) 2010..2012  Tibor 'Igor2' Palinkas

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    Project page: http://repo.hu/projects/libporty
    Author: libporty@igor2.repo.hu
*/

#include <stdlib.h>
#include <libporty/config.h>
#include "bgtask.h"


#ifdef WIN32
#include <windows.h>
int P_bgtask_create(P_bgtask_entry_t entry, void *arg)
{
	return (CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)entry, arg, 0, NULL) == NULL);
}
#else
#include <pthread.h>
int P_bgtask_create(P_bgtask_entry_t entry, void *arg)
{
	pthread_t t;
	return pthread_create(&t, NULL, (void * (*)(void *))entry, arg);
}
#endif
