#include <libporty/net/network.h>

/* Run background process binding stdio to fd, stderr is left alone and
   all other fds are closed. argv[0] is the command to be run followed
   by all the arguments (argv[1] doesn't need to reproduce the process name)
   terminated by a NULL entry.
   ctrlfd is an optional control fd; using this the caller may monitor
   exit status of the process or kill it.
*/
int P_net_async_bgproc(P_net_socket *fd, char *argv[], P_net_socket *ctrlfd);

/* Same as P_net_async_bgproc, plus redirect stderr (if fd_err is non-NULL) and
   inherit listed P_net_sockets (inherit_len is the number of P_net_sockets to
   be inherited). */
int P_net_async_bgproc_inherit(P_net_socket *fd, char *argv[], P_net_socket *ctrlfd, P_net_socket *fd_err, P_net_socket *inherit_list, int inherit_len);


/* --- for internal use, for the wrapper --- */

#ifndef WIN32
/* close all irrelevant fds leaving stdio only */
void P_net_async_bgproc_closefds(P_net_socket *inherit_list, int inherit_len);
#endif
