#!/bin/sh

# use this script as "CC=./cc.sh make" to parse c files of a project

C99TREE=c99tree

# glibc stuff + defines + includes
CPPFLAGS="$CPPFLAGS -D__asm=asm \
-D__asm__=asm \
-D__signed=signed \
-D__signed__=signed \
-D__inline=inline \
-D__inline__=inline \
-D__const=const \
-D__const__=const \
-D__volatile=volatile \
-D__volatile__=volatile \
-D__restrict=restrict \
-D__restrict__=restrict \
-D__attribute=__attribute__ \
-D__extension__= \
-D__typeof=typeof \
-D__typeof__=typeof \
-D__label__=void \
-D__builtin_va_list=void"`echo "$@" | awk '{
	for (i = 1; i <= NF; i++) {
		if ($i ~ /^-[DUI]$/)
			printf " %s", $i $(i+1)
		else if ($i ~ /^-[DUI]/)
			printf " %s", $i
	}
}'`

for i in "$@"; do
	echo "$i" | grep -q '\.c$' || continue
#	echo "gcc -E $CPPFLAGS $i >$i.E"
	gcc -E $CPPFLAGS $i >$i.E
	$C99TREE <$i.E >$i.TREE
done
