#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <libporty/host/time.h>

/* short sleep in microseconds */
#define refsleep 8192.0

/* long sleep in seconds */
#define refsleep_long 2.2

int main()
{
	P_time_t secs1, usecs1, secs2, usecs2, ds, du;
	double d1, d2, dd;


	/* Test 1:
	  query system time before and after sleeping refsleep microseconds then
 	  check if actual time elapsed during the sleep is within some sane range;
 	  tolerance is +0..50% */

	/* first test with P_ltime... */
	P_ltime(&secs1, &usecs1);
	P_usleep(refsleep);
	P_ltime(&secs2, &usecs2);
	ds = secs2-secs1;
	if (usecs2 < usecs1) {
		du = 1000000 - usecs2 - usecs1;
		ds--;
	}
	else
		du = usecs2 - usecs1;
	printf("P_usleep with P_ltime: %d\n", (ds == 0) && (du > refsleep) && (du < refsleep*1.5));

	/* ... then with P_dtime */
	d1 = P_dtime();
	P_usleep(refsleep);
	d2 = P_dtime();
	dd = d2 - d1;
	printf("P_usleep with P_dtime: %d\n", (dd > (refsleep/1000000.0)) && (dd < (refsleep/1000000.0*1.5)));

	/* Test 2
	   check if P_dsleep works; since the much longer sleep here, tolerance
	   is only +0..5% */
	printf("Sleeping %f seconds...\n", refsleep_long);
	d1 = P_dtime();
	P_dsleep(refsleep_long);
	d2 = P_dtime();
	dd = d2 - d1;
	printf("P_usleep with P_dtime: %d\n", (dd > (refsleep_long)) && (dd < (refsleep_long*1.05)));
}
